VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CB_AddModule"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Callback adding shared module from file
Option Explicit

Private iOut_ As IteratorSharedModule
Private tester_ As VBIDE.VBProject
Private base_ As String
Private fso_ As Scripting.FileSystemObject

Private Type ProcedureDescriptor
  name_ As String
  type_ As VBIDE.vbext_ProcKind
End Type

Public Function Init(iOut As IteratorSharedModule, oTestProject As VBIDE.VBProject, sBasePath$)
  Set iOut_ = iOut
  base_ = sBasePath
  Set tester_ = oTestProject
  Set fso_ = New Scripting.FileSystemObject
End Function

Public Function TryAddModule(aFile As Scripting.File)
  If Not IsVBAModuleExtension(fso_.GetExtensionName(aFile.Name)) Then _
    Exit Function
  
  Dim sPath$: sPath = aFile.Path
  Dim aComp As VBIDE.VBComponent
  Set aComp = tester_.VBComponents.Import(sPath)
  
  With iOut_
    .Name = aComp.Name
    .ModuleType = aComp.Type
    .Path = VBA.Mid(sPath, Len(base_) + 2, VBA.Len(sPath) - VBA.Len(base_) - 2 - VBA.Len(aFile.Name))
    .Version = ExtractVersion(aComp.CodeModule)
    .LoC = aComp.CodeModule.CountOfLines
    .Declarations = aComp.CodeModule.CountOfDeclarationLines
    .CountAPI = Dev_CountPublicAPI(aComp.CodeModule)
    
    Call .Increment
  End With
  
  Call tester_.VBComponents.Remove(aComp)
End Function

' =====
Private Function ExtractVersion(target As VBIDE.CodeModule) As String
  Const VERSION_PREFIX$ = "module version: "
  Dim nLine&
  For nLine = 1 To target.CountOfLines Step 1
    Dim sTxt$: sTxt = target.Lines(nLine, 1)
    Dim nPrefix&: nPrefix = InStr(1, sTxt, VERSION_PREFIX)
    If nPrefix <> 0 Then
      ExtractVersion = Right(sTxt, Len(sTxt) - nPrefix + 1 - Len(VERSION_PREFIX))
      Exit Function
    End If
  Next nLine
End Function
