VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "InfoGlobals"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Const CELL_SHARED_HOME = "c_SharedHome"
Private Const CELL_CODE_BASE = "c_CodeBase"
Private Const CELL_ARTIFACT_HOME = "c_ArtifactsHome"
Private Const CELL_DEFAULT_REFS = "c_DefaultRefs"
Private Const CELL_LOG_FLAG = "c_LogFlag"
Private Const CELL_LOG_FOLDER = "c_LogLocation"
Private Const CELL_DISTRIBUTION = "c_Distribution"

Private Const TABLE_GLOBAL_REFS = "t_GlobalRefs"

Private Const RANGE_TEMPLATES = "r_Templates"

Public build_ As TBuildType

Private Sub Class_Initialize()
  build_ = T_BUILD_DEBUG
End Sub

Public Property Get Logger() As API_Logger
  Static s_Log As API_Logger
  If s_Log Is Nothing Then
    Set s_Log = New API_Logger
    If ThisWorkbook.Names(CELL_LOG_FLAG).RefersToRange = "True" Then
      Dim sName$: sName = GenerateLogFilename(ThisWorkbook.Names(CELL_LOG_FOLDER).RefersToRange)
      Call s_Log.Init(sName)
    End If
  End If
  Set Logger = s_Log
End Property

Public Property Get References() As DB_GlobalRefs
  Static s_Refs As DB_GlobalRefs
  If s_Refs Is Nothing Then
    Set s_Refs = New DB_GlobalRefs
    Call s_Refs.Init(ThisWorkbook.Worksheets(SHEET_PARAMETERS).ListObjects(TABLE_GLOBAL_REFS))
  End If
  Set References = s_Refs
End Property

Public Property Get SourceHome() As String
  SourceHome = ThisWorkbook.Names(CELL_CODE_BASE).RefersToRange
End Property

Public Property Get SharedHome() As String
  SharedHome = ThisWorkbook.Names(CELL_SHARED_HOME).RefersToRange
End Property

Public Property Get ArtifactHome() As String
  ArtifactHome = ThisWorkbook.Names(CELL_ARTIFACT_HOME).RefersToRange
End Property

Public Property Get DistributionHome() As String
  DistributionHome = ThisWorkbook.Names(CELL_DISTRIBUTION).RefersToRange
End Property

Public Function TemplatePaths() As Collection
  Dim dataRange As Excel.Range: Set dataRange = ThisWorkbook.Names(RANGE_TEMPLATES).RefersToRange
  Dim cResult As New Collection
  Dim aCell As Excel.Range
  For Each aCell In dataRange
    Dim sTxt$: sTxt = aCell
    If sTxt <> vbNullString Then _
      Call cResult.Add(CPath(sTxt).ToGlobal(ThisWorkbook.Path).Text)
  Next aCell
  Set TemplatePaths = cResult
End Function

Public Function DefaultRefs() As String
  DefaultRefs = ThisWorkbook.Names(CELL_DEFAULT_REFS).RefersToRange
End Function

' ==========
Private Function GenerateLogFilename(sFolder$) As String
  GenerateLogFilename = sFolder & "\" & Format(Now(), "yyyy-mm-dd") & ".txt"
End Function
