VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "DB_Products"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private data_ As Excel.Worksheet
Private components_ As DB_Components

Public Function Init(target As Excel.Worksheet, iComponents As DB_Components)
  Set components_ = iComponents
  Set data_ = target
End Function

Public Function IBegin() As IteratorProduct
  Set IBegin = New IteratorProduct
  Call IBegin.Init(data_)
End Function

Public Function ILast() As IteratorProduct
  Set ILast = New IteratorProduct
  Call ILast.Init(data_)
  Call ILast.GoLast
End Function

Public Function INew() As IteratorProduct
  Set INew = New IteratorProduct
  Call INew.Init(data_)
  Call INew.GoLast
  Call INew.Increment
End Function

Public Function Contains(sProduct$) As Boolean
  Contains = Not Access(sProduct) Is Nothing
End Function

Public Function Access(sProduct$) As IteratorProduct
  Dim iProd As New IteratorProduct: Call iProd.Init(data_)
  Do While Not iProd.IsDone
    If iProd.Name = sProduct Then
      Set Access = iProd
      Exit Function
    End If
    Call iProd.Increment
  Loop
End Function

Public Function Insert(iMake As InfoMakefile) As Boolean
  Insert = Not Contains(iMake.ProductName)
  If Not Insert Then _
    Exit Function
  
  Dim iNewProduct As IteratorProduct: Set iNewProduct = INew
  Call iNewProduct.SyncMakefile(iMake)
  Call iNewProduct.SyncManifests(iMake, components_)
End Function
