VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "s_VsoWrapper"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Note: Testing only functions different from API_WordWrapper
' TODO: test open document flags

Private vso_ As API_VsoWrapper
Private fso_ As Scripting.FileSystemObject

Public Function Setup()
  ' Mandatory setup function
  Set vso_ = New API_VsoWrapper
  Call vso_.DisableMessages
  Call vso_.CreateApplication
  Set fso_ = New Scripting.FileSystemObject
  Call EnsureFolderExists(Dev_GetTestFolder)
End Function

Public Function Teardown()
  ' Mandatory teardown function
  Call fso_.DeleteFolder(Dev_GetTestFolder)
  Call vso_.ReleaseApplication
  Set vso_ = Nothing
End Function

Public Function t_SaveAs()
  On Error GoTo PROPAGATE_ERROR
  
  Dim sTemplate$: sTemplate = Dev_GetTestFolder & "\" & "testFile"
  Dim sFile$: sFile = sTemplate & ".vsdx"
  Dim sTarget$
  Dim oReader As New API_VsoWrapper
  Call oReader.CreateApplication
  Call oReader.DisableMessages

  Call Dev_NewCase("No document")
  On Error Resume Next
  Call Dev_ExpectFalse(vso_.SaveAs(sFile))
  Call Dev_ExpectNoError
  On Error Resume Next
  
  Call vso_.NewDocument
  Call vso_.Document.Pages(1).DrawRectangle(1, 1, 2, 2)
  Call Dev_ExpectFalse(vso_.SaveAs("invalid!?"), "Invalid filename")

  Call Dev_NewCase("Save as vsdx")
  sTarget = sTemplate & ".vsdx"
  Call Dev_ExpectTrue(vso_.SaveAs(sTarget))
  Call vso_.ReleaseDocument(bCloseApplication:=False)
  Call Dev_ExpectTrue(fso_.FileExists(sTarget), "File created")
  Call Dev_AssertTrue(oReader.OpenDocument(sTarget), "Open saved document")
  Call Dev_ExpectEQ(1, oReader.Document.Pages(1).Shapes.Count, "Validate contents")
  Call oReader.ReleaseDocument(bCloseApplication:=False)

  Call Dev_NewCase("Save as vsdm")
  Call vso_.OpenDocument(sFile)
  sTarget = sTemplate & ".vsdm"
  Call Dev_ExpectTrue(vso_.SaveAs(sTarget))
  Call vso_.ReleaseDocument(bCloseApplication:=False)
  Call Dev_AssertTrue(fso_.FileExists(sTarget), "File created")
  Call Dev_ExpectTrue(oReader.OpenDocument(sTarget), "Open saved document")
  Call Dev_ExpectEQ(1, oReader.Document.Pages(1).Shapes.Count, "Validate contents")
  Call oReader.ReleaseDocument(bCloseApplication:=False)

  Call Dev_NewCase("Save as vstx")
  Call vso_.OpenDocument(sFile)
  sTarget = sTemplate & ".vstx"
  Call Dev_ExpectTrue(vso_.SaveAs(sTarget))
  Call vso_.ReleaseDocument(bCloseApplication:=False)
  Call Dev_AssertTrue(fso_.FileExists(sTarget), "File created")
  Call Dev_ExpectTrue(oReader.OpenDocument(sTarget), "Open saved document")
  Call Dev_ExpectEQ(1, oReader.Document.Pages(1).Shapes.Count, "Validate contents")
  Call oReader.ReleaseDocument(bCloseApplication:=False)
  
  Call Dev_NewCase("Save as vstm")
  Call vso_.OpenDocument(sFile)
  sTarget = sTemplate & ".vstm"
  Call Dev_ExpectTrue(vso_.SaveAs(sTarget))
  Call vso_.ReleaseDocument(bCloseApplication:=False)
  Call Dev_AssertTrue(fso_.FileExists(sTarget), "File created")
  Call Dev_ExpectTrue(oReader.OpenDocument(sTarget), "Open saved document")
  Call Dev_ExpectEQ(1, oReader.Document.Pages(1).Shapes.Count, "Validate contents")
  Call oReader.ReleaseDocument(bCloseApplication:=False)
  
  Call oReader.ReleaseApplication
  
  Exit Function
PROPAGATE_ERROR:
  Call Dev_LogError(Err.Number, Err.Description)
End Function
